VERSION 5.00
Begin VB.UserControl CHyperLink 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00FF00FF&
   CanGetFocus     =   0   'False
   ClientHeight    =   300
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2715
   MaskColor       =   &H00FF00FF&
   PropertyPages   =   "XHyperLink.ctx":0000
   ScaleHeight     =   300
   ScaleWidth      =   2715
   ToolboxBitmap   =   "XHyperLink.ctx":0023
   Begin VB.Timer tmrMouseOut 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   2295
      Top             =   0
   End
   Begin VB.Label lblText 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "lblText"
      Height          =   195
      Left            =   45
      MouseIcon       =   "XHyperLink.ctx":011D
      MousePointer    =   99  'Custom
      TabIndex        =   0
      Top             =   45
      Width           =   465
   End
End
Attribute VB_Name = "CHyperLink"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
    
Public Enum lnkAlignment
    AlignLeft = 0
    AlignRight = 1
    AlignCenter = 2
End Enum

'Valeurs par dfaut !
Private Const cBackColor = vbButtonFace
Private Const cCaption = "HyperLink"
Private Const cTarget = ""
Private Const cForeColor = vbButtonText
Private Const cOnForeColor = vbActiveTitleBar
Private Const cEnabled = True
Private Const cMoveUnderline = False
Private Const cAutoSize = True
Private Const cWordWrap = False
Private Const cActiveDownColor = False
Private Const cAlignment = AlignLeft

'Proprits :
Private myBackColor As OLE_COLOR 'BackColor
Private myForeColor As OLE_COLOR 'ForeColor
Private myOnForeColor As OLE_COLOR 'OnForeColor
Private myDownForeColor As OLE_COLOR 'DownForeColor
Private myCaption As String 'Caption
Private myFont As Font 'Font
Private myTarget As String 'Target
Private myEnabled As Boolean 'Enabled
Private myMoveUnderline As Boolean 'Enabled
Private myAutoSize As Boolean 'AutoSize
Private myWordWrap As Boolean 'WordWrap
Private myActiveDownColor As Boolean 'ActiveDownColor
Private myAlignment As lnkAlignment 'Alignment

Private mySerialNumber As String 'SerialNumber

'Evnements :
Event Change()
Event Click(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event DblClick()
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseOut()
Event Resize()
Event Show()
Event Terminate()

'Proprits
'-------------------------------------------------------------------------------------
Public Property Get SerialNumber() As String
    SerialNumber = mySerialNumber
End Property

Public Property Let SerialNumber(ByVal Value As String)
    Call PropertyChanged("SerialNumber")
    Call Refresh
End Property

Public Property Get hwnd() As Long
    hwnd = UserControl.hwnd
End Property

Public Property Get ActiveDownColor() As Boolean
    ActiveDownColor = myActiveDownColor
End Property

Public Property Let ActiveDownColor(ByVal Value As Boolean)
    myActiveDownColor = Value
    Call PropertyChanged("ActiveDownColor")
    Call Refresh
End Property

Public Property Get Alignment() As lnkAlignment
    Alignment = myAlignment
End Property

Public Property Let Alignment(ByVal Value As lnkAlignment)
    myAlignment = Value
    Call PropertyChanged("Alignment")
    Call Refresh
End Property

Public Property Get AutoSize() As Boolean
    AutoSize = myAutoSize
End Property

Public Property Let AutoSize(ByVal Value As Boolean)
    myAutoSize = Value
    Call PropertyChanged("AutoSize")
    Call Refresh
End Property

Public Property Get WordWrap() As Boolean
    WordWrap = myWordWrap
End Property

Public Property Let WordWrap(ByVal Value As Boolean)
    myWordWrap = Value
    Call PropertyChanged("WordWrap")
    Call Refresh
End Property

Public Property Get MoveUnderline() As Boolean
    MoveUnderline = myMoveUnderline
End Property

Public Property Let MoveUnderline(ByVal Value As Boolean)
    myMoveUnderline = Value
    Call PropertyChanged("MoveUnderline")
    Call Refresh
End Property

Public Property Get Enabled() As Boolean
    Enabled = myEnabled
End Property

Public Property Let Enabled(ByVal Value As Boolean)
    myEnabled = Value
    Call PropertyChanged("Enabled")
    Call Refresh
End Property

Public Property Get Caption() As String
    Caption = myCaption
End Property

Public Property Let Caption(ByVal Value As String)
    myCaption = Value
    Call PropertyChanged("Caption")
    Call Refresh
End Property

Public Property Get Font() As Font
    Set Font = myFont
End Property

Public Property Set Font(ByVal Value As Font)
    Set myFont = Value
    Call PropertyChanged("Font")
    Call Refresh
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = myBackColor
End Property

Public Property Let BackColor(ByVal Value As OLE_COLOR)
    myBackColor = Value
    Call PropertyChanged("BackColor")
    Call Refresh
End Property

Public Property Get ForeColor() As OLE_COLOR
    ForeColor = myForeColor
End Property

Public Property Let ForeColor(ByVal Value As OLE_COLOR)
    myForeColor = Value
    Call PropertyChanged("ForeColor")
    Call Refresh
End Property

Public Property Get OnForeColor() As OLE_COLOR
    OnForeColor = myOnForeColor
End Property

Public Property Let OnForeColor(ByVal Value As OLE_COLOR)
    myOnForeColor = Value
    Call PropertyChanged("OnForeColor")
    Call Refresh
End Property

Public Property Get DownForeColor() As OLE_COLOR
    DownForeColor = myDownForeColor
End Property

Public Property Let DownForeColor(ByVal Value As OLE_COLOR)
    myDownForeColor = Value
    Call PropertyChanged("DownForeColor")
    Call Refresh
End Property

Public Property Get Target() As String
    Target = myTarget
End Property

Public Property Let Target(ByVal Value As String)
    myTarget = Value
    Call PropertyChanged("Target")
    Call Refresh
End Property
'-------------------------------------------------------------------------------------

Private Sub lbltext_Change()
On Error Resume Next
    Call Refresh
    RaiseEvent Change
End Sub

Private Sub lbltext_DblClick()
On Error Resume Next
    Call Refresh
    RaiseEvent DblClick
End Sub

Private Sub lbltext_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
On Error Resume Next
    If (Button = 1 And Shift = 0 And myActiveDownColor = True) Then lblText.ForeColor = myDownForeColor
    
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub lbltext_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
On Error Resume Next
    If (Button = 0 And Shift = 0) Then
        If (lblText.ForeColor <> myOnForeColor) Then lblText.ForeColor = myOnForeColor
        If (myMoveUnderline = True And lblText.Font.Underline = False) Then lblText.Font.Underline = True
    End If
    
    tmrMouseOut.Enabled = True
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub lbltext_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
On Error Resume Next
    Call Refresh
    
    If (Button = 1 And Shift = 0 And (X >= 0 And Y >= 0) And (X <= UserControl.Width And Y <= UserControl.Height) And myTarget <> "") Then Call ShellExecute(UserControl.hwnd, "open", myTarget, "", "", SW_NORMAL)
    If (Button = 1 And Shift = 0 And (X >= 0 And Y >= 0) And (X <= UserControl.Width And Y <= UserControl.Height)) Then RaiseEvent Click(Button, Shift, X, Y)
    
    If (myFont.Underline = False) Then lblText.Font.Underline = False
    
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

Private Sub tmrMouseOut_Timer()
On Error Resume Next
    If (UnderMouse(UserControl.hwnd) = False) Then: Call Refresh: tmrMouseOut.Enabled = False: RaiseEvent MouseOut
End Sub

Private Sub UserControl_InitProperties()
On Error Resume Next

    myCaption = cCaption
    Set myFont = Ambient.Font
    myBackColor = cBackColor
    myTarget = cTarget
    myOnForeColor = cOnForeColor
    myForeColor = cForeColor
    myEnabled = cEnabled
    myDownForeColor = myOnForeColor
    myMoveUnderline = cMoveUnderline
    myAutoSize = cAutoSize
    myWordWrap = cWordWrap
    myActiveDownColor = cActiveDownColor
    myAlignment = cAlignment
    
    mySerialNumber = genSerialNumber

    Call Refresh
End Sub

Private Sub UserControl_Paint()
On Error Resume Next
    Call Refresh
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
On Error Resume Next

    myCaption = PropBag.ReadProperty("Caption", cCaption)
    Set myFont = PropBag.ReadProperty("Font", Ambient.Font)
    myTarget = PropBag.ReadProperty("Target", cTarget)
    myOnForeColor = PropBag.ReadProperty("OnForeColor", cOnForeColor)
    myDownForeColor = PropBag.ReadProperty("DownForeColor", myOnForeColor)
    myForeColor = PropBag.ReadProperty("ForeColor", cForeColor)
    myBackColor = PropBag.ReadProperty("BackColor", cBackColor)
    myEnabled = PropBag.ReadProperty("Enabled", cEnabled)
    myMoveUnderline = PropBag.ReadProperty("MoveUnderline", cMoveUnderline)
    myAutoSize = PropBag.ReadProperty("AutoSize", cAutoSize)
    myWordWrap = PropBag.ReadProperty("WordWrap", cWordWrap)
    myActiveDownColor = PropBag.ReadProperty("ActiveDownColor", cActiveDownColor)
    myAlignment = PropBag.ReadProperty("Alignment", cAlignment)
    
    mySerialNumber = PropBag.ReadProperty("SerialNumber", genSerialNumber)
    
    Call Refresh
End Sub

Private Sub UserControl_Resize()
On Error Resume Next

    lblText.Left = 0 'Screen.TwipsPerPixelX * 5
    lblText.Top = 0
    
    If (myAutoSize = True) Then
        
        If (myWordWrap = False) Then
            UserControl.Width = lblText.Width + lblText.Left * 2
        End If
        
        lblText.AutoSize = False: lblText.AutoSize = True
        UserControl.Height = lblText.Height + lblText.Top * 2
    
    Else
        lblText.Width = UserControl.Width
        lblText.Height = UserControl.Height
    End If
End Sub

Private Sub UserControl_Show()
On Error Resume Next
    RaiseEvent Show
    Call Refresh
End Sub

Private Sub UserControl_Terminate()
On Error Resume Next
    RaiseEvent Terminate
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
On Error Resume Next
    
    Call PropBag.WriteProperty("Target", myTarget, cTarget)
    Call PropBag.WriteProperty("Caption", myCaption, cCaption)
    Call PropBag.WriteProperty("Font", myFont, Ambient.Font)
    Call PropBag.WriteProperty("BackColor", myBackColor, cBackColor)
    Call PropBag.WriteProperty("OnForeColor", myOnForeColor, cOnForeColor)
    Call PropBag.WriteProperty("DownForeColor", myDownForeColor, myOnForeColor)
    Call PropBag.WriteProperty("ForeColor", myForeColor, cForeColor)
    Call PropBag.WriteProperty("Enabled", myEnabled, cEnabled)
    Call PropBag.WriteProperty("MoveUnderline", myMoveUnderline, cMoveUnderline)
    Call PropBag.WriteProperty("AutoSize", myAutoSize, cAutoSize)
    Call PropBag.WriteProperty("WordWrap", myWordWrap, cWordWrap)
    Call PropBag.WriteProperty("ActiveDownColor", myActiveDownColor, cActiveDownColor)
    Call PropBag.WriteProperty("Alignment", myAlignment, cAlignment)
    
    Call PropBag.WriteProperty("SerialNumber", mySerialNumber, genSerialNumber)
    
    Call Refresh
End Sub

Public Sub Refresh()
On Error Resume Next
    
    UserControl.BackColor = myBackColor
    lblText.ForeColor = myForeColor
    
    Set lblText.Font = myFont
    lblText.Caption = myCaption
    lblText.Enabled = myEnabled
    lblText.AutoSize = Not myAutoSize: lblText.AutoSize = myAutoSize
    lblText.WordWrap = myWordWrap
    lblText.Alignment = myAlignment
    
    If (myMoveUnderline = True) Then lblText.Font.Underline = False
    
    Call UserControl_Resize
End Sub

