VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ProgressBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long

'Cr une rgion en forme d'llipse entre les points (X1,Y1) et (X2,Y2)
Private Declare Function CreateEllipticRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long

'Combine deux rgions pour en crer unr troisime selon le mode nCombineMode
Private Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long

'Supprime un objet et libre de la mmoire
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

'Cr une feuille ayant la forme d'une rgion
Private Declare Function SetWindowRgn Lib "user32" (ByVal hwnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long


'Constantes pour CombineRgn
 Const RGN_AND = 1        'Intersection des deux rgions
 Const RGN_OR = 2         'Addition des deux rgions
 Const RGN_XOR = 3        'Difficile  dcrire ... essayez
                                'En fait, c'est un XOR : l'addition des 2 rgions
                                'en retirant les parties communes aux 2 rgions
 Const RGN_DIFF = 4       'Soustraction de la rgion 2  la rgion 1
 Const RGN_COPY = 5       'Copie la rgion 1

Dim cercleRgn1 As Long
Dim picRgn As Long
Dim CercleRgn2 As Long
Dim rgn1 As Long
Dim rgn2 As Long

Public Value As Single
Public Color As Long
Dim pict As PictureBox
Sub CreateProgressBar(Pic As PictureBox, TypeOfProgressBar As Integer)
Dim PicHeight As Single, PicWidth As Long
PicHeight = Pic.Height / Screen.TwipsPerPixelY
PicWidth = Pic.Width / Screen.TwipsPerPixelX



If TypeOfProgressBar = 0 Then
rgn1 = CreateRectRgn(0, 0, Pic.Width / Screen.TwipsPerPixelX, Pic.Height / Screen.TwipsPerPixelY)
rgn2 = CreateRectRgn(0, 0, Pic.Width / Screen.TwipsPerPixelX, Pic.Height / Screen.TwipsPerPixelY)

cercleRgn1 = CreateEllipticRgn((10 * (Pic.Width / Screen.TwipsPerPixelY)) / 100, (Pic.Height / Screen.TwipsPerPixelY) / 2, (Pic.Width / Screen.TwipsPerPixelX) - ((10 * (Pic.Width / Screen.TwipsPerPixelY)) / 100), Pic.Width / Screen.TwipsPerPixelY)

picRgn = CreateRectRgn(1, 0, Pic.Width / Screen.TwipsPerPixelX, Pic.Height / Screen.TwipsPerPixelY)

CombineRgn rgn1, picRgn, cercleRgn1, RGN_DIFF

CercleRgn2 = CreateEllipticRgn(1, (Pic.Height / Screen.TwipsPerPixelY) / 8, Pic.Width / Screen.TwipsPerPixelX, Pic.Width / Screen.TwipsPerPixelY)

CombineRgn rgn2, rgn1, CercleRgn2, RGN_AND

SetWindowRgn Pic.hwnd, rgn2, True
End If

If TypeOfProgressBar = 1 Then

rgn1 = CreateRectRgn(0, 0, PicWidth, PicHeight)
rgn2 = CreateRectRgn(0, 0, PicWidth, PicHeight)

cercleRgn1 = CreateEllipticRgn((10 * PicWidth) / 100, -PicHeight / 2, PicWidth - ((10 * PicWidth) / 100), PicWidth / 3)

picRgn = CreateRectRgn(1, 0, PicWidth, PicHeight)

CombineRgn rgn1, picRgn, cercleRgn1, RGN_DIFF

CercleRgn2 = CreateEllipticRgn(1, -7 * PicHeight / 8, PicWidth, PicWidth / 2)

CombineRgn rgn2, rgn1, CercleRgn2, RGN_AND

SetWindowRgn Pic.hwnd, rgn2, True
End If

If TypeOfProgressBar = 2 Then

rgn1 = CreateRectRgn(0, 0, PicWidth, PicHeight)
rgn2 = CreateRectRgn(0, 0, PicWidth, PicHeight)

cercleRgn1 = CreateEllipticRgn((10 * PicWidth) / 100, -PicHeight / 2, PicWidth - ((10 * PicWidth) / 100), PicWidth / 2)

picRgn = CreateRectRgn(1, 0, PicWidth, PicHeight)

CombineRgn rgn1, picRgn, cercleRgn1, RGN_DIFF

CercleRgn2 = CreateEllipticRgn(1, -PicHeight / 8, PicWidth, PicWidth / 2)

CombineRgn rgn2, rgn1, CercleRgn2, RGN_AND

SetWindowRgn Pic.hwnd, rgn2, True
End If


If TypeOfProgressBar = 3 Then

rgn1 = CreateRectRgn(0, 0, PicWidth, PicHeight)
rgn2 = CreateRectRgn(0, 0, PicWidth, PicHeight)

cercleRgn1 = CreateEllipticRgn((10 * PicWidth) / 100, -PicHeight / 2, PicWidth - ((10 * PicWidth) / 100), PicWidth / 2)

picRgn = CreateRectRgn(1, 0, PicWidth, PicHeight)

CombineRgn rgn1, picRgn, cercleRgn1, RGN_DIFF

CercleRgn2 = CreateEllipticRgn(1, -PicHeight / 8, PicWidth, PicWidth)

CombineRgn rgn2, rgn1, CercleRgn2, RGN_AND

SetWindowRgn Pic.hwnd, rgn2, True
End If


If TypeOfProgressBar = 4 Then

rgn1 = CreateRectRgn(0, 0, PicWidth, PicHeight)
rgn2 = CreateRectRgn(0, 0, PicWidth, PicHeight)

cercleRgn1 = CreateEllipticRgn((10 * PicWidth) / 100, 0, PicWidth - ((10 * PicWidth) / 100), PicWidth / 2)

picRgn = CreateRectRgn(1, 0, PicWidth, PicHeight)

CombineRgn rgn1, picRgn, cercleRgn1, RGN_DIFF

CercleRgn2 = CreateEllipticRgn(1, -7 * PicHeight / 8, PicWidth, PicWidth / 2)

CombineRgn rgn2, rgn1, CercleRgn2, RGN_AND

SetWindowRgn Pic.hwnd, rgn2, True
End If

Pic.ScaleMode = 3
Pic.AutoRedraw = True
Set pict = Pic
End Sub

Sub UpdateValue()
pict.Cls
For i = 0 To (pict.ScaleWidth * Value) / 100
pict.Line (i, 0)-(i, pict.Height), Color
Next i
End Sub

Sub Unload()
DeleteObject cercleRgn1
DeleteObject CercleRgn2
DeleteObject rgn1
DeleteObject rgn2
DeleteObject picRgn
End Sub

