VERSION 5.00
Begin VB.UserControl MaxBox 
   CanGetFocus     =   0   'False
   ClientHeight    =   5010
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6060
   ControlContainer=   -1  'True
   ScaleHeight     =   5010
   ScaleWidth      =   6060
   ToolboxBitmap   =   "MaxBox.ctx":0000
   Begin MaxBox3D.SwitchButton CmdCaption 
      Height          =   375
      Left            =   240
      Top             =   0
      Width           =   1815
      _ExtentX        =   3201
      _ExtentY        =   661
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      CaptionTop      =   6
      CaptionLeft     =   42
   End
   Begin VB.Frame Frame 
      Height          =   3255
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   3015
   End
End
Attribute VB_Name = "MaxBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'==================================================================================
'   Ralisation de Frdric Just
'   Commentaires remarques et critiques :
'
'   adresse en cours    : fred.just@free.fr
'   site actuel         : http://fred.just.free.fr/
'   adresse de secours  : fredjust@hotmail.com
'==================================================================================

Option Explicit
'Valeurs de proprits par dfaut:
Const m_def_ButtonHeight = 270
Const m_def_IsOpen = True
Const m_def_OpenSize = 3000
Const m_def_CloseSize = 375
'Variables de proprits:
Dim m_ButtonHeight As Long
Dim m_IsOpen As Boolean
Dim m_OpenSize As Long
Dim m_CloseSize As Long
'Dclarations d'vnements:
Event Expand()
Event Collapse()
Event ButtonMouseMouve(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event ButtonMouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event BoxMouseMouve(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event BoxMouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)



'===============================================================================
'
'===============================================================================
Private Sub CmdCaption_Click()
    If m_IsOpen Then
        CloseBox
    Else
        OpenBox
    End If
    UserControl.Extender.ZOrder
End Sub

Private Sub CmdCaption_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent ButtonMouseDown(Button, Shift, X, Y)
End Sub

'===============================================================================
'
'===============================================================================
Private Sub CmdCaption_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent ButtonMouseMouve(Button, Shift, X, Y)
End Sub

Private Sub Frame_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent BoxMouseDown(Button, Shift, X, Y)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent BoxMouseMouve(Button, Shift, X, Y)
End Sub

'===============================================================================
'
'===============================================================================
Private Sub UserControl_Resize()
    Frame.Move 0, 0, UserControl.Width, UserControl.Height
    CmdCaption.Move 120, 0, UserControl.Width - 240, m_ButtonHeight
    If Not Ambient.UserMode And m_IsOpen Then
        OpenSize = UserControl.Height
    End If
End Sub

'ATTENTION! NE SUPPRIMEZ PAS OU NE MODIFIEZ PAS LES LIGNES COMMENTES SUIVANTES!
'MappingInfo=CmdCaption,CmdCaption,-1,Caption
Public Property Get Caption() As String
Attribute Caption.VB_Description = "Renvoie ou dfinit le texte affich dans la barre de titre d'un objet ou sous l'icne d'un objet."
    Caption = CmdCaption.Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
    CmdCaption.Caption() = New_Caption
    PropertyChanged "Caption"
End Property

'ATTENTION! NE SUPPRIMEZ PAS OU NE MODIFIEZ PAS LES LIGNES COMMENTES SUIVANTES!
'MemberInfo=8,0,0,3000
Public Property Get OpenSize() As Long
    OpenSize = m_OpenSize
End Property

Public Property Let OpenSize(ByVal New_OpenSize As Long)
    m_OpenSize = New_OpenSize
    PropertyChanged "OpenSize"
End Property

'ATTENTION! NE SUPPRIMEZ PAS OU NE MODIFIEZ PAS LES LIGNES COMMENTES SUIVANTES!
'MemberInfo=8,0,0,375
Public Property Get CloseSize() As Long
    CloseSize = m_CloseSize
End Property

Public Property Let CloseSize(ByVal New_CloseSize As Long)
    m_CloseSize = New_CloseSize
    PropertyChanged "CloseSize"
End Property

'Initialiser les proprits pour le contrle utilisateur
Private Sub UserControl_InitProperties()
    m_OpenSize = m_def_OpenSize
    m_CloseSize = m_def_CloseSize
    m_IsOpen = m_def_IsOpen
'    m_OpenOnOver = m_def_OpenOnOver
'    m_SwitchMode = m_def_SwitchMode
    m_ButtonHeight = m_def_ButtonHeight
    CmdCaption.Height = m_ButtonHeight
End Sub

'Charger les valeurs des proprits  partir du stockage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
On Error Resume Next
    CmdCaption.Caption = PropBag.ReadProperty("Caption", "Caption")
    m_OpenSize = PropBag.ReadProperty("OpenSize", m_def_OpenSize)
    m_CloseSize = PropBag.ReadProperty("CloseSize", m_def_CloseSize)
    m_IsOpen = PropBag.ReadProperty("IsOpen", m_def_IsOpen)
    CmdCaption.Style = PropBag.ReadProperty("SwitchMode", 0)
    m_ButtonHeight = PropBag.ReadProperty("ButtonHeight", m_def_ButtonHeight)
    CmdCaption.Height = m_ButtonHeight
    CmdCaption.BackColor = PropBag.ReadProperty("ButtonColor", &H8000000F)
    CmdCaption.BackColorDown = PropBag.ReadProperty("ButtonColorDown", &H80000005)
    Frame.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    CmdCaption.Position = PropBag.ReadProperty("ButtonPosition", 1)
End Sub

'crire les valeurs des proprits dans le stockage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
On Error Resume Next
    Call PropBag.WriteProperty("Caption", CmdCaption.Caption, "Caption")
    Call PropBag.WriteProperty("OpenSize", m_OpenSize, m_def_OpenSize)
    Call PropBag.WriteProperty("CloseSize", m_CloseSize, m_def_CloseSize)
    Call PropBag.WriteProperty("IsOpen", m_IsOpen, m_def_IsOpen)
    Call PropBag.WriteProperty("SwitchMode", CmdCaption.Style, 0)
    Call PropBag.WriteProperty("ButtonHeight", m_ButtonHeight, m_def_ButtonHeight)
    CmdCaption.Height = m_ButtonHeight
    Call PropBag.WriteProperty("ButtonColor", CmdCaption.BackColor, &H8000000F)
    Call PropBag.WriteProperty("ButtonColorDown", CmdCaption.BackColorDown, &H80000005)
    Call PropBag.WriteProperty("BackColor", Frame.BackColor, &H8000000F)
    Call PropBag.WriteProperty("ButtonPosition", CmdCaption.Position, 1)
End Sub

'ATTENTION! NE SUPPRIMEZ PAS OU NE MODIFIEZ PAS LES LIGNES COMMENTES SUIVANTES!
'MemberInfo=0,0,0,true
Public Property Get IsOpen() As Boolean
    IsOpen = m_IsOpen
End Property

Public Property Let IsOpen(ByVal New_IsOpen As Boolean)
    m_IsOpen = New_IsOpen
    If IsOpen Then OpenBox Else CloseBox
    PropertyChanged "IsOpen"
End Property

'==================================================================================
'
'==================================================================================
Public Sub OpenBox()
    UserControl.Height = m_OpenSize
    m_IsOpen = True
    RaiseEvent Expand
End Sub

'==================================================================================
'
'==================================================================================
Public Sub CloseBox()
    UserControl.Height = m_CloseSize
    m_IsOpen = False
    RaiseEvent Collapse
End Sub

'ATTENTION! NE SUPPRIMEZ PAS OU NE MODIFIEZ PAS LES LIGNES COMMENTES SUIVANTES!
'MappingInfo=CmdCaption,CmdCaption,-1,Style
Public Property Get SwitchMode() As EnumStyle
    SwitchMode = CmdCaption.Style
End Property

Public Property Let SwitchMode(ByVal New_SwitchMode As EnumStyle)
    CmdCaption.Style() = New_SwitchMode
    PropertyChanged "SwitchMode"
End Property

'ATTENTION! NE SUPPRIMEZ PAS OU NE MODIFIEZ PAS LES LIGNES COMMENTES SUIVANTES!
'MemberInfo=8,0,0,270
Public Property Get ButtonHeight() As Long
    ButtonHeight = m_ButtonHeight
End Property

Public Property Let ButtonHeight(ByVal New_ButtonHeight As Long)
    m_ButtonHeight = New_ButtonHeight
    CmdCaption.Height = m_ButtonHeight
    PropertyChanged "ButtonHeight"
End Property

'ATTENTION! NE SUPPRIMEZ PAS OU NE MODIFIEZ PAS LES LIGNES COMMENTES SUIVANTES!
'MappingInfo=CmdCaption,CmdCaption,-1,BackColor
Public Property Get ButtonColor() As OLE_COLOR
Attribute ButtonColor.VB_Description = "Renvoie ou dfinit la couleur de premier plan utilise pour afficher le texte et les graphiques d'un objet."
    ButtonColor = CmdCaption.BackColor
End Property

Public Property Let ButtonColor(ByVal New_ButtonColor As OLE_COLOR)
    CmdCaption.BackColor() = New_ButtonColor
    PropertyChanged "ButtonColor"
End Property

'ATTENTION! NE SUPPRIMEZ PAS OU NE MODIFIEZ PAS LES LIGNES COMMENTES SUIVANTES!
'MappingInfo=CmdCaption,CmdCaption,-1,BackColorDown
Public Property Get ButtonColorDown() As OLE_COLOR
Attribute ButtonColorDown.VB_Description = "Renvoie ou dfinit la couleur de remplissage des formes, des cercles et des botes."
    ButtonColorDown = CmdCaption.BackColorDown
End Property

Public Property Let ButtonColorDown(ByVal New_ButtonColorDown As OLE_COLOR)
    CmdCaption.BackColorDown() = New_ButtonColorDown
    PropertyChanged "ButtonColorDown"
End Property

'ATTENTION! NE SUPPRIMEZ PAS OU NE MODIFIEZ PAS LES LIGNES COMMENTES SUIVANTES!
'MappingInfo=Frame,Frame,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Renvoie ou dfinit la couleur d'arrire-plan utilise pour afficher le texte et les graphiques d'un objet."
    BackColor = Frame.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    Frame.BackColor() = New_BackColor
    PropertyChanged "BackColor"
End Property

'ATTENTION! NE SUPPRIMEZ PAS OU NE MODIFIEZ PAS LES LIGNES COMMENTES SUIVANTES!
'MappingInfo=CmdCaption,CmdCaption,-1,Position
Public Property Get ButtonPosition() As EnumPosition
    ButtonPosition = CmdCaption.Position
End Property

Public Property Let ButtonPosition(ByVal New_ButtonPosition As EnumPosition)
    CmdCaption.Position() = New_ButtonPosition
    PropertyChanged "ButtonPosition"
End Property

