VERSION 5.00
Begin VB.UserControl SysTitle 
   Alignable       =   -1  'True
   ClientHeight    =   1020
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   8430
   Picture         =   "SysTitle.ctx":0000
   ScaleHeight     =   1020
   ScaleWidth      =   8430
   ToolboxBitmap   =   "SysTitle.ctx":02E2
   Begin VB.PictureBox PIC 
      Align           =   1  'Align Top
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      CausesValidation=   0   'False
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FFFFFF&
      Height          =   270
      Left            =   0
      ScaleHeight     =   270
      ScaleWidth      =   8430
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   0
      Width           =   8430
      Begin VB.Image IMico 
         Height          =   240
         Left            =   15
         Picture         =   "SysTitle.ctx":05F4
         Stretch         =   -1  'True
         Top             =   15
         Width           =   240
      End
   End
End
Attribute VB_Name = "SysTitle"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'==================================================================================
'   permet de crer des bars de titre multicouleur pour les applications
'   (encore plus impressionant avec les MDI )
'   Utilisation d'un module du site VBaccelerator.com
'   ameliorations prvues
'       ecriture vertical pour placer la bar de titre sur les cots
'       (deja tester mais non stable :-(
'
'   si vous trouvez un BUG ou que vous enrichisser cet OCX
'   merci de me faire parvenir vos amliorations et/ou commentaires
'
'   adresse en cours    : fred.just@free.fr
'   site actuel         : http://fred.just.free.fr/
'   adresse de secours  : fredjust@hotmail.com
'
'==================================================================================

Option Explicit



'==================================================================================
'
'==================================================================================
Private Type RECT
    left As Long
    tOp As Long
    Right As Long
    Bottom As Long
End Type

Private Type POINTAPI
    X As Long
    Y As Long
End Type

Dim CursorStart As POINTAPI

'==================================================================================
'
'==================================================================================
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Private Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Const LOGPIXELSX = 88    '  Logical pixels/inch in X
Private Const LOGPIXELSY = 90    '  Logical pixels/inch in Y
Private Declare Function MulDiv Lib "kernel32" (ByVal nNumber As Long, ByVal nNumerator As Long, ByVal nDenominator As Long) As Long
Private Const LF_FACESIZE = 32

Private Type LOGFONT
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName(LF_FACESIZE) As Byte
End Type

Private Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Const FW_NORMAL = 400
Private Const FW_BOLD = 700
Private Const FF_DONTCARE = 0
Private Const DEFAULT_PITCH = 0
Private Const DEFAULT_CHARSET = 1
Private Declare Function OleTranslateColor Lib "OLEPRO32.DLL" (ByVal OLE_COLOR As Long, ByVal HPALETTE As Long, pccolorref As Long) As Long
Private Const CLR_INVALID = -1
Private Declare Function SetGraphicsMode Lib "gdi32" (ByVal hdc As Long, ByVal iMode As Long) As Long
Private Const GM_ADVANCED = 2
Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Private Declare Function lstrlen Lib "kernel32" Alias "lstrlenA" (ByVal lpString As String) As Long

' lfQuality Constants:
Private Const DEFAULT_QUALITY = 0    ' Appearance of the font is set to default
Private Const DRAFT_QUALITY = 1    ' Appearance is less important that PROOF_QUALITY.
Private Const PROOF_QUALITY = 2    ' Best character quality
Private Const NONANTIALIASED_QUALITY = 3    ' Don't smooth font edges even if system is set to smooth font edges
Private Const ANTIALIASED_QUALITY = 4    ' Ensure font edges are smoothed if system is set to smooth font edges

Private m_picThis As PictureBox

Private m_bRGBStart(1 To 3) As Integer
Private m_bRGBEnd(1 To 3) As Integer
'Dclarations d'vnements:
Event DblClick()    'MappingInfo=PIC,PIC,-1,DblClick
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)    'MappingInfo=PIC,PIC,-1,MouseDown
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)    'MappingInfo=PIC,PIC,-1,MouseMove
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)    'MappingInfo=PIC,PIC,-1,MouseUp

'Valeurs de proprits par dfaut:
Const m_def_StartColor = 0
Const m_def_Caption = "FormFake"
Const m_def_EndColor As Long = 255
'Variables de proprits:
Dim m_StartColor As OLE_COLOR
Dim m_Caption As String
Dim m_EndColor As OLE_COLOR


'==================================================================================
'
'==================================================================================
Private Sub Draw()
    Dim lHeight As Long, lWidth As Long
    Dim lXStep As Long
    Dim lX As Long
    Dim bRGB(1 To 3) As Long
    Dim tLF As LOGFONT
    Dim hFnt As Long
    Dim hFntOld As Long
    Dim lR As Long
    Dim tR As RECT
    Dim rct As RECT
    Dim hBr As Long
    Dim hdc As Long
    Dim dR(1 To 3) As Double
    Dim dx As Double
    Dim Toto As Long
    
       
    On Error GoTo DrawError

    hdc = m_picThis.hdc

    lWidth = m_picThis.Width \ Screen.TwipsPerPixelX
    rct.Bottom = m_picThis.Height \ Screen.TwipsPerPixelY


    ' Set a graduation of 255 pixels:
    lXStep = lWidth \ 255
    If (lXStep = 0) Then
        lXStep = 1
    End If
    rct.left = 0
    LSet tR = rct

    bRGB(1) = m_bRGBStart(1)
    bRGB(2) = m_bRGBStart(2)
    bRGB(3) = m_bRGBStart(3)
    dR(1) = m_bRGBEnd(1) - m_bRGBStart(1)
    dR(2) = m_bRGBEnd(2) - m_bRGBStart(2)
    dR(3) = m_bRGBEnd(3) - m_bRGBStart(3)

    For lX = lWidth To 0 Step -lXStep
        ' Draw bar:
        rct.Right = rct.left + lXStep
        hBr = CreateSolidBrush((bRGB(3) * &H10000 + bRGB(2) * &H100& + bRGB(1)))
        FillRect hdc, rct, hBr
        DeleteObject hBr
        rct.left = rct.Right
        ' Adjust colour:
        dx = (lWidth - lX) / lWidth
        bRGB(1) = m_bRGBStart(1) + dR(1) * dx
        bRGB(2) = m_bRGBStart(2) + dR(2) * dx
        bRGB(3) = m_bRGBStart(3) + dR(3) * dx
    Next lX

    pOLEFontToLogFont m_picThis.Font, hdc, tLF
    hFnt = CreateFontIndirect(tLF)
    If (hFnt <> 0) Then
        hFntOld = SelectObject(hdc, hFnt)
        Toto = 2 + IMico.Width \ 15
        lR = TextOut(hdc, Toto, 2, m_Caption, lstrlen(m_Caption))
        SelectObject hdc, hFntOld
        DeleteObject hFnt
    End If

    m_picThis.Refresh
    Exit Sub
DrawError:
    Debug.Print "Problem: " & Err.Description
End Sub


'==================================================================================
'
'==================================================================================
Private Sub pOLEFontToLogFont(fntThis As StdFont, hdc As Long, tLF As LOGFONT)
    Dim sFont As String
    Dim iChar As Integer

    ' Convert an OLE StdFont to a LOGFONT structure:
    With tLF
        sFont = fntThis.Name
        ' There is a quicker way involving StrConv and CopyMemory, but
        ' this is simpler!:
        For iChar = 1 To Len(sFont)
            .lfFaceName(iChar - 1) = CByte(Asc(Mid$(sFont, iChar, 1)))
        Next iChar
        ' Based on the Win32SDK documentation:
        .lfHeight = -MulDiv((fntThis.Size), (GetDeviceCaps(hdc, LOGPIXELSY)), 72)
        .lfItalic = fntThis.Italic
        If (fntThis.Bold) Then
            .lfWeight = FW_BOLD
        Else
            .lfWeight = FW_NORMAL
        End If
        .lfUnderline = fntThis.Underline
        .lfStrikeOut = fntThis.Strikethrough
        .lfCharSet = fntThis.Charset
        .lfQuality = ANTIALIASED_QUALITY
        .lfHeight = fntThis.Size
    End With

End Sub

'==================================================================================
'
'==================================================================================
Private Sub PIC_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub UserControl_InitProperties()
    Set m_picThis = PIC
    m_Caption = m_def_Caption
    m_StartColor = m_def_StartColor
    EndColor = RGB(IIf(Rnd * 10 > 4.5, 255, 0), IIf(Rnd * 10 > 4.5, 255, 0), IIf(Rnd * 10 > 4.5, 255, 0))
End Sub

'==================================================================================
'Load property values from storage
'==================================================================================
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Set m_picThis = PIC
    Set IconPicture = PropBag.ReadProperty("IconPicture", IMico.Picture)
    Set PIC.Font = PropBag.ReadProperty("Font", PIC.Font)
    m_Caption = PropBag.ReadProperty("Caption", m_def_Caption)
    m_StartColor = PropBag.ReadProperty("StartColor", m_def_StartColor)
    EndColor = PropBag.ReadProperty("EndColor", m_def_EndColor)
    PIC.ForeColor = PropBag.ReadProperty("CaptionColor", &HFFFFFF)
End Sub
'==================================================================================
'
'==================================================================================
Private Sub UserControl_Resize()
    PIC.Height = Height
    Draw
End Sub

'==================================================================================
'Write property values to storage
'==================================================================================
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("IconPicture", IconPicture, IMico.Picture)
    Call PropBag.WriteProperty("Font", PIC.Font, Ambient.Font)
    Call PropBag.WriteProperty("Caption", m_Caption, m_def_Caption)
    Call PropBag.WriteProperty("EndColor", m_EndColor, m_def_EndColor)
    Call PropBag.WriteProperty("CaptionColor", PIC.ForeColor, &HFFFFFF)
    Call PropBag.WriteProperty("StartColor", m_StartColor, m_def_StartColor)
End Sub


'ATTENTION! NE SUPPRIMEZ PAS OU NE MODIFIEZ PAS LES LIGNES COMMENTES SUIVANTES!
'MappingInfo=IMico,IMico,-1,Picture
Public Property Get IconPicture() As Picture
Attribute IconPicture.VB_Description = "Renvoie ou dfinit un graphisme  afficher dans un contrle."
    Set IconPicture = IMico.Picture
End Property

Public Property Set IconPicture(ByVal New_Picture As Picture)
    Set IMico.Picture = New_Picture
    PropertyChanged "IconPicture"
End Property



'ATTENTION! NE SUPPRIMEZ PAS OU NE MODIFIEZ PAS LES LIGNES COMMENTES SUIVANTES!
'MappingInfo=PIC,PIC,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Renvoie un objet Font."
Attribute Font.VB_UserMemId = -512
    Set Font = PIC.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set PIC.Font = New_Font
    PropertyChanged "Font"
    Draw
End Property

Private Sub PIC_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub PIC_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

Private Sub PIC_DblClick()
    RaiseEvent DblClick
End Sub

'ATTENTION! NE SUPPRIMEZ PAS OU NE MODIFIEZ PAS LES LIGNES COMMENTES SUIVANTES!
'MemberInfo=13,0,0,FormFake
Public Property Get Caption() As String
    Caption = m_Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
    m_Caption = New_Caption
    PropertyChanged "Caption"
    Draw
End Property

'ATTENTION! NE SUPPRIMEZ PAS OU NE MODIFIEZ PAS LES LIGNES COMMENTES SUIVANTES!
'MemberInfo=10,0,0,255
Public Property Get EndColor() As OLE_COLOR
    EndColor = m_EndColor
End Property

Public Property Let EndColor(ByVal oColor As OLE_COLOR)
    Dim lColor As Long
    m_EndColor = oColor
    OleTranslateColor oColor, 0, lColor
    m_bRGBEnd(1) = lColor And &HFF&
    m_bRGBEnd(2) = ((lColor And &HFF00&) \ &H100)
    m_bRGBEnd(3) = ((lColor And &HFF0000) \ &H10000)
    PropertyChanged "EndColor"
    Draw
End Property


'ATTENTION! NE SUPPRIMEZ PAS OU NE MODIFIEZ PAS LES LIGNES COMMENTES SUIVANTES!
'MappingInfo=PIC,PIC,-1,ForeColor
Public Property Get CaptionColor() As OLE_COLOR
Attribute CaptionColor.VB_Description = "Renvoie ou dfinit la couleur de premier plan utilise pour afficher le texte et les graphiques d'un objet."
    CaptionColor = PIC.ForeColor
End Property

Public Property Let CaptionColor(ByVal New_CaptionColor As OLE_COLOR)
    PIC.ForeColor() = New_CaptionColor
    PropertyChanged "CaptionColor"
    Draw
End Property

'ATTENTION! NE SUPPRIMEZ PAS OU NE MODIFIEZ PAS LES LIGNES COMMENTES SUIVANTES!
'MemberInfo=10,0,0,64
Public Property Get StartColor() As OLE_COLOR
    StartColor = m_StartColor
End Property

Public Property Let StartColor(ByVal oColor As OLE_COLOR)
Dim lColor As Long
    m_StartColor = oColor
    OleTranslateColor oColor, 0, lColor
    m_bRGBStart(1) = lColor And &HFF&
    m_bRGBStart(2) = ((lColor And &HFF00&) \ &H100)
    m_bRGBStart(3) = ((lColor And &HFF0000) \ &H10000)
    PropertyChanged "StartColor"
    Draw
End Property

Public Sub About()
    MsgBox ";-) Fred Just SysFake BarTitle OCX" & Chr(13) & _
        "It's a FreeWare !" & Chr(13) & _
        "You can use this OCX in your project" & Chr(13) & _
        "Check my site or mail me" & Chr(13) & _
        "fredjust@hotmail.com", vbInformation, "About SysFake.ocx"
End Sub

